"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createClientBaseConfig = void 0;
var shared_1 = require("@dev-scripts/shared");
// utilities
var path_1 = require("path");
// Loaders
var fonts_loader_1 = require("../loaders/fonts-loader");
var image_loader_1 = require("../loaders/image-loader");
var javascript_typescript_1 = require("../loaders/javascript-typescript");
var style_loader_1 = require("../loaders/style-loader");
// Plugins
var plugins_1 = require("../plugins/plugins");
var shared_config_1 = require("../shared-config");
// Config files
var isProduction = (0, shared_1.getDefaultMode)() === 'production';
var createClientBaseConfig = function (options) {
    var contenthash = isProduction && shared_1.devConfig.contenthash ? '.[contenthash]' : '';
    var outputFilename = "".concat(shared_1.devConfig.jsOutputPath, "[name]").concat(contenthash, ".js");
    var outputChunkFilename = "".concat(shared_1.devConfig.jsOutputPath, "chunks/[name]").concat(contenthash, ".js");
    var entry = {
        main: shared_1.devConfig.clientEntry,
    };
    var config = __assign(__assign({}, shared_config_1.sharedConfig), { target: 'web', name: 'client', entry: entry, plugins: __spreadArray([], (0, plugins_1.getPlugins)(true, options.manifestSharedSeed), true), module: {
            rules: __spreadArray(__spreadArray(__spreadArray([], (0, javascript_typescript_1.default)({
                includedPackages: options.includedPackages,
            }), true), (0, style_loader_1.default)(), true), [
                //Assets
                (0, image_loader_1.default)(),
                (0, fonts_loader_1.default)(),
            ], false),
        }, output: {
            filename: (0, shared_1.normalizePath)(outputFilename),
            chunkFilename: (0, shared_1.normalizePath)(outputChunkFilename),
            path: (0, path_1.join)(shared_1.devConfig.clientDist, shared_1.devConfig.publicPath),
            publicPath: shared_1.devConfig.publicPath,
        } });
    return config;
};
exports.createClientBaseConfig = createClientBaseConfig;
//# sourceMappingURL=client.base.js.map