"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var shared_1 = require("@dev-scripts/shared");
var fs_1 = require("fs");
var extendFilePath = "".concat(shared_1.projectDirectory, "/babel.extend.js");
var hasExtendFile = (0, fs_1.existsSync)(extendFilePath);
var configureBabelLoader = function (_a) {
    var _b = _a.includedPackages, includedPackages = _b === void 0 ? [] : _b;
    var options = {
        plugins: ['@babel/plugin-proposal-class-properties', '@babel/plugin-transform-runtime'],
        presets: [
            [
                '@babel/preset-env',
                {
                    targets: (0, shared_1.findSupportedBrowsers)(),
                    useBuiltIns: 'entry',
                    corejs: '3.6',
                },
            ],
        ],
        cacheDirectory: (0, shared_1.getDefaultMode)() === 'development',
    };
    if (hasExtendFile) {
        options = require(extendFilePath)(options);
    }
    return [
        {
            test: /\.(ts|tsx)?$/,
            exclude: includedPackages,
            use: [
                {
                    loader: 'babel-loader',
                    options: options,
                },
                {
                    loader: 'ts-loader',
                },
            ],
        },
        {
            test: /\.(js|jsx)?$/,
            exclude: includedPackages,
            use: [
                {
                    loader: 'babel-loader',
                    options: options,
                },
            ],
        },
    ];
};
exports.default = configureBabelLoader;
//# sourceMappingURL=javascript-typescript.js.map