"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createServerBaseConfig = void 0;
var shared_1 = require("@dev-scripts/shared");
var nodeExternals = require('webpack-node-externals');
// Loaders
var fonts_loader_1 = require("../loaders/fonts-loader");
var image_loader_1 = require("../loaders/image-loader");
var javascript_typescript_1 = require("../loaders/javascript-typescript");
var style_loader_1 = require("../loaders/style-loader");
// Plugins
var plugins_1 = require("../plugins/plugins");
var shared_config_1 = require("../shared-config");
var createServerBaseConfig = function (options) {
    var outputFilename = "server.js";
    var config = __assign(__assign({}, shared_config_1.sharedConfig), { target: 'node', name: 'server', entry: {
            server: shared_1.devConfig.serverEntry,
        }, plugins: __spreadArray([], (0, plugins_1.getPlugins)(false), true), module: {
            rules: __spreadArray(__spreadArray(__spreadArray([], (0, javascript_typescript_1.default)({
                includedPackages: options.includedPackages,
            }), true), (0, style_loader_1.default)({
                isClient: false,
            }), true), [
                //Assets
                (0, image_loader_1.default)(false),
                (0, fonts_loader_1.default)(false),
            ], false),
        }, output: {
            filename: (0, shared_1.normalizePath)(outputFilename),
            libraryTarget: 'commonjs2',
            path: shared_1.devConfig.serverDist,
            publicPath: shared_1.devConfig.publicPath,
        }, node: {
            __filename: false,
            __dirname: false,
        }, externals: ['./asset-manifest.json', nodeExternals()] });
    return config;
};
exports.createServerBaseConfig = createServerBaseConfig;
//# sourceMappingURL=server.base.js.map